#importation de tous les modules utilisés
from tkinter import *
import os
import json
import requests
import datetime
from PIL import Image


date=datetime.date.today()# stockage de la date dans une variable
#Indication des données nécessaire a l'obtention de l'image dans l'API (clé, image recherchée, date)
params={
    'api_key':'RGGQQWlcCQ86fQiuMcn4kym791rXFz3hkYUrcnhM',
    'hd':'True',
    'date': date
}

response=requests.get("https://api.nasa.gov/planetary/apod",params=params)#Obtention du code source de l'image
img = requests.get(json.loads(response.content)["hdurl"])#Stockage d'un fichier contenant l'image dans une variable

#Création d'un fichier temporaire de l'image puis modification de sa résolution pour être utilisable en fond d'écran
temporaire=open('fondecrantemporaire.png', 'wb')
temporaire.write(img.content)
Fond=Image.open('fondecrantemporaire.png')
FonDecran=Fond.resize((1920,1080))
FonDecran.save("fondecrantemporaire.png")

#Création de l'interface graphique
fenetre = Tk()
fenetre.attributes("-fullscreen", True)
fenetre.title("fond d'écran ?")
fenetre['bg']='black'
fenetre.resizable(height=False,width=False)

#Ajout de l'image temporaire dans l'interface
photo=PhotoImage(file="fondecrantemporaire.png")
photo2=photo.subsample(2,2)
lb=Label(fenetre,image=photo2)
lb.pack()

directory=os.getcwd()#Obtention du path actuel du dossier pour y revenir plus tard

#Définition de la fonction principale du programme, activée par le bouton
def fond():
    if os.uname().sysname=="Linux" :

        #Pour linuxMint, remplacement de l'image de fond d'écran par l'image temporaire et création d'un fichier "backup" contenant l'ancien fond d'écran
        if os.path.exists("/usr/share/backgrounds/linuxmint/default_background.jpg") :#La méthode utilisée pour détécter la version de l'ordinateur est la vérification de l'existance du fichier fond d'écran spécifique
            Backup=Image.open("/usr/share/backgrounds/linuxmint/default_background.jpg")
            os.chdir("/usr/share/backgrounds/linuxmint/")
            Backup.save("backup.png")
            FonDecran.save("default_background.jpg")

        #Idem pour Xubuntu
        if os.path.exists("/usr/share/xfce4/backdrops/xubuntu-wallpaper.png"):
            Backup=Image.open("/usr/share/xfce4/backdrops/xubuntu-wallpaper.png")
            os.chdir("/usr/share/xfce4/backdrops")
            Backup.save("backup.png")
            FonDecran.save("xubuntu-wallpaper.png")

        #Idem pour Ubuntu
        if os.path.exists("/usr/share/backgrounds/warty-final-ubuntu.png") :
            Backup=Image.open("/usr/share/backgrounds/warty-final-ubuntu.png")
            os.chdir("/usr/share/backgrounds")
            Backup.save("backup.png")
            FonDecran.save('warty-final-ubuntu.png')


    temporaire.close()
    Fond.close()
    fenetre.destroy()

#Création d'un bouton contenu dans un canvas éxecutant le programme principal
can = Canvas()
bouton = Button(can, text=" je veux cette image en fond d'écran",font=("Berlin Sans FB",13), bg= 'black', fg="white", command=fond)
bouton.grid(column=0, row=0, ipady=10)

#Ajout d'un deuxieme bouton premettant de quitter la fenêtre sans executer le programme principal
bouton2 = Button(can, text="je ne veux pas cette image en fond d'écran",font=("Berlin Sans FB",13), bg= 'black', fg="white", command=fenetre.destroy)
bouton2.grid(column=1, row=0, ipady=10)

#Suppression du fichier temporaire créé plus haut dans le path original
os.chdir(directory)
os.remove("fondecrantemporaire.png")

#Suivent ici trois conditionnelles qui verifient si le programme a déjà été utilisé et le cas échéant ajoutent un troisième bouton au canvas remplaçant le fond d'écran par l'ancien fond d'écran stocké dans le fichier "backup"
if os.path.exists("/usr/share/backgrounds/warty-final-ubuntu.png/backup.png") :#On vérifie l'éxistance d'un ancien fond d'écran appelé backup pour Ubuntu
    def rebackup() :#Définition de la fonction appelée par le bouton
        #Remplacement du fond d'écran par l'ancien fond d'écran nommé "backup"
        os.chdir("/usr/share/backgrounds/")
        Backup=Image.open("backup.png")
        Backup.save("warty-final-ubuntu.png")
        os.remove("backup.png")
        fenetre.destroy()

    #Ajout du bouton dans le canvas
    bouton3 = Button(can, text=" je veux revenir à mon ancien fond d'écran", font=("Berlin Sans FB",13), bg="black", fg="white", command=rebackup)
    bouton3.grid(column=2, row=0, ipady=10)

#Idem pour Xubuntu
if os.path.exists("/usr/share/xfce4/backdrops/backup.png"):
    def rebackup() :
        os.chdir("/usr/share/xfce4/backdrops")
        Backup=Image.open("backup.png")
        Backup.save("xubuntu-wallpaper.png")
        os.remove("backup.png")
        fenetre.destroy()
    bouton3 = Button(can, text=" je veux revenir à mon ancien fond d'écran", font=("Berlin Sans FB",13), bg="black", fg="white", command=rebackup)
    bouton3.grid(column=2, row=0, ipady=10)

#Idem pour Linuxmint
if os.path.exists("/usr/share/backgrounds/linuxmint/backup.png") :
    def rebackup() :
        os.chdir("/usr/share/backgrounds/linuxmint/")
        Backup=Image.open("backup.png")
        Backup.save("default_background.jpg")
        os.remove("backup.png")
        fenetre.destroy()
    bouton3 = Button(can, text=" je veux revenir à mon ancien fond d'écran", font=("Berlin Sans FB",13), bg="black", fg="white", command=rebackup)
    bouton3.grid(column=2, row=0, ipady=10)




can.pack(side=BOTTOM)#Installation des boutons en bas
fenetre.mainloop()

